<?php

namespace Drupal\smart_content\Cache;

use Drupal\Core\Ajax\AjaxResponse;
use Drupal\Core\Ajax\AjaxResponseAttachmentsProcessor;
use Symfony\Component\HttpFoundation\Request;

/**
 * Provides temporary solve for cacheable ajax requests.
 *
 * @link https://www.drupal.org/project/drupal/issues/956186.
 *
 * @see Drupal\smart_content\Cache\CacheableAjaxResponse
 */
class CacheableAjaxResponseAttachmentsProcessor extends AjaxResponseAttachmentsProcessor {

  /**
   * {@inheritdoc}
   */
  protected function buildAttachmentsCommands(AjaxResponse $response, Request $request) {
    $commands = $response->getCommands();
    $ajax_page_state = $request->query->get('ajax_page_state');
    if ($ajax_page_state && !$request->request->has('ajax_page_state')) {
      $request->request->set('ajax_page_state', $ajax_page_state);
      $commands = parent::buildAttachmentsCommands($response, $request);
      $request->request->remove('ajax_page_state');
    }
    return $commands;
  }

}
